app.popup.receive("icon", function (e) {
  app.download.getFileIcon(e, function (data) {
    app.popup.send("icon", data);
  });
});

app.popup.receive("erase", function (e) {
  app.download.erase(e, function () {
    config.popupsend({"reset": true, "listener": false, "progress": false, "loop": true}, 0);
  });
});

app.popup.receive("remove", function (e) {
  app.download.removeFile(e, function () {
    config.popupsend({"reset": true, "listener": false, "progress": false, "loop": true}, 1);
  });
});

app.popup.receive("orderBy", function (e) {
  config.download.orderBy = e;
  config.popupsend({"reset": true, "listener": false, "progress": false, "loop": true}, 2);
});

app.popup.receive("maxitems", function (e) {
  config.download.maxitems = e;
  config.popupsend({"reset": true, "listener": false, "progress": false, "loop": true}, 3);
});

app.popup.receive("thread", function (e) {
  config.download.threads = e;
  app.popup.send("thread", config.download.threads);
  /*  */
  config.update.thread.colors();
});

app.popup.receive("search", function (e) {
  if (e && e.query && e.query[0]) {
    app.download.search(e, function (items) {
      config.popupsend({"reset": true, "listener": false, "progress": false, "downloads": items, "loop": false}, 4);
    });
  } else config.popupsend({"reset": true, "listener": true, "progress": false, "loop": true}, 5);
});

app.popup.receive("download", function (url) {
  if (url) {
    try {
      config.download.url = url;
      app.download.download(config.download.url);
    } catch (e) {
      app.notifications.create("Invalid URL!\nPlease add a correct URL and try again.");
    };
  }
});

app.download.onchanged(function (e) {
  if ("native" in e) {
    const OLD = config.starttime[e.id];
    delete config.starttime[e.id];
    config.starttime[e.native.id] = OLD;
  } else {
    if (config.starttime[e.id] === undefined) {
      config.starttime[e.id] = (new Date()).toISOString();
    }
  }
  /*  */
  app.download.search({}, function (items) {
    config.download.items = items;
    config.blink.icon();
    /*  */
    config.popupsend({"reset": true, "listener": false, "progress": false, "downloads": items, "loop": true}, 6);
  });
  /*  */
  if (e.state && e.state.current && e.state.current === "complete") {
    app.download.search({"id": e.id}, function (items) {
      if (items[0]) {
        app.notifications.create("Download is complete.\n" + items[0].filename);
      }
    });
  }
});

app.popup.receive("referrer", function (e) {app.tab.open(e)});
app.popup.receive("open", function (e) {app.download.open(e)});
app.popup.receive("pause", function (e) {app.download.pause(e)});
app.popup.receive("cancel", function (e) {app.download.cancel(e)});
app.popup.receive("resume", function (e) {app.download.resume(e)});
app.popup.receive("support", function (e) {app.tab.open(app.homepage())});
app.popup.receive("folder", function () {app.download.showDefaultFolder()});
app.popup.receive("donation", function (e) {app.tab.open(app.homepage() + "?reason=support")});
app.popup.receive("load", function () {config.popupsend({"reset": true, "listener": true, "progress": false, "loop": true}, 7)});

app.button.init(function () {
  config.blink.icon();
  config.update.thread.colors();
  app.contextmenu.create.button();
  app.contextmenu.create.page(app.download.download);
});
