var config = {};

config.tii = 1;
config.starttime = {};
config.timeout = null;
config.interval = null;
config.url = chrome.runtime.getURL;

config.log = function (e) {
  //console.error(e);
};

config.number = function (n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
};

config.welcome = {
  set lastupdate (val) {app.storage.write("lastupdate", val)},
  get lastupdate () {return app.storage.read("lastupdate") !== undefined ? app.storage.read("lastupdate") : 0}
};

config.limit = {
  "items": function (e) {
    return e.slice(0, config.download.maxitems);
  }
};

config.randomcolor = function () {
  var min = 0, max = 170;
  var R = Math.floor(Math.random() * (max - min)) + min;
  var B = Math.floor(Math.random() * (max - min)) + min;
  var G = Math.floor(Math.random() * (max - min)) + min;
  /*  */
  return "rgb(" + R + ',' + G + ',' + B + ')';
};

config.clear = {
  "items": function (e) {
    return e.map(obj => {
      const item = Object.assign({}, obj);
      delete item.file;
      return item;
    });
  }
};

config.update = {
  "thread": {
    "colors": function () {
      var colors = [];
      var max = 10 * config.download.threads * config.download.maxitems;
      for (var i = 0; i < max; i++) {
        colors.push(config.randomcolor());
      }
      /*  */
      config.download.colors = colors;
    }
  }
};

config.download = {
  "tmp": {"array": []},
  set url (val) {app.storage.write("url", val)},
  get items () {return config.download.tmp.array},
  set items (val) {config.download.tmp.array = val},
  set colors (val) {app.storage.write("colors", val)},
  set orderBy (val) {app.storage.write("orderBy", val)},
  set maxitems (val) {app.storage.write("maxitems", val)},
  set threads (val) {app.storage.write("threads", (val > 5 ? 5 : val))},
  get url () {return app.storage.read("url") !== undefined ? app.storage.read("url") : ''},
  get colors () {return app.storage.read("colors") !== undefined ? app.storage.read("colors") : []},
  get threads () {return app.storage.read("threads") !== undefined ? app.storage.read("threads") : 5},
  get maxitems () {return app.storage.read("maxitems") !== undefined ? app.storage.read("maxitems") : 30},
  get orderBy () {return app.storage.read("orderBy") !== undefined ? app.storage.read("orderBy") : "state"}
};

config.order = {
  "items": function (e) {
    return e.sort(function (a, b) {
      var key = {};
      var id = config.download.orderBy;
      if (id) {
        key.a = a ? a[id] : null;
        key.b = b ? b[id] : null;
        if (key.a && key.b) {
          if (key.a < key.b) return -1;
          if (key.a > key.b) return 1;
        }
      }
      /*  */
      return 0;
    });
  }
};

config.listener = function (loop) {
  if (config.interval) window.clearTimeout(config.interval);
  if (loop) {
    config.interval = window.setTimeout(function () {
      app.download.search({"state": "in_progress"}, function (items) {
        if (items.length) {
          config.download.items = items;
          config.popupsend({
            "loop": loop,
            "reset": false,
            "progress": true,
            "listener": false,
            "downloads": items,
          }, 8);
        } else window.clearTimeout(config.interval);
      });
    }, 1000);
  }
};

config.blink = {
  "icon": function () {
    var items = config.download.items;
    if (items && items.length) {
      for (var i = 0; i < items.length; i++) {
        var item = items[i];
        if (item.state === "in_progress" && item.paused === false) {
          if (config.tii > 3) config.tii = 1;
          app.button.icon(config.tii);
          config.tii = config.tii + 1;
          if (config.timeout) window.clearTimeout(config.timeout);
          config.timeout = window.setTimeout(config.blink.icon, 400);
          /*  */
          return;
        }
      }
      /*  */
      return app.button.icon(null);
    }
  }
};

config.add = {
  "start": {
    "time": function (e) {
      return e.map(item => {
        if (item["startTime"] === undefined) {
          var time = config.starttime[item.id];
          if (time) item["startTime"] = time;
        }
        /*  */
        if (item["_startTime"] === undefined) {
          var time = config.starttime[item.id] || item["startTime"];
          if (time) item["_startTime"] = (new Date(time)).getTime();
        }
        /*  */
        return item;
      });
    }
  }
};

config.popupsend = function (e, loc) {
  var send = function (items) {
    var downloads = [];
    downloads = config.add.start.time(items);
    downloads = config.clear.items(downloads);
    downloads = config.order.items(downloads);
    downloads = config.limit.items(downloads);
    /*  */
    config.download.items = items;
    app.popup.send("load", {
      "reset": e.reset,
      "listener": e.listener,
      "progress": e.progress,
      "data": {
        "downloads": downloads,
        "url": config.download.url,
        "colors": config.download.colors,
        "orderBy": config.download.orderBy,
        "threads": config.download.threads,
        "maxitems": config.download.maxitems
      }
    });
    /*  */
    config.listener(e.loop);
  };
  /*  */
  if (e.downloads) send(e.downloads);
  else app.download.search({}, send);
};
