app.button = {
  "init": function (callback) {
    chrome.storage.local.get({"context": "popup"}, function (storage) {
      app.interface.url = app.interface.path + '?' + storage.context;
      chrome.browserAction.setPopup({"popup": (storage.context === "popup" ? app.interface.url : '')}, callback);
    });
  },
  "icon": function (e) {
    var path = e ? ("/progress/" + e + '/') : '/';
    chrome.browserAction.setIcon({"path": {
      "16": "../../data/icons/toolbar" + path + "16.png",
      "32": "../../data/icons/toolbar" + path + "32.png",
      "48": "../../data/icons/toolbar" + path + "48.png",
      "64": "../../data/icons/toolbar" + path + "64.png"
    }});
  },
  "click": function () {
    chrome.storage.local.get({"context": "popup"}, function (storage) {
      app.interface.url = app.interface.path + '?' + storage.context;
      if (storage.context === "win") {
        app.interface.id ? chrome.windows.update(app.interface.id, {"focused": true}) : app.interface.create();
      } else if (storage.context === "tab") {
        app.interface.id ? chrome.tabs.update(app.interface.id, {"active": true}) : app.tab.open(app.interface.url);
      } else {}
    });
  }
};

chrome.browserAction.onClicked.addListener(app.button.click);
