app.contextmenu = {
  "click": function (e) {
    chrome.storage.local.get({"context": "popup"}, function (storage) {
      app.interface.close(storage.context);
      /*  */
      app.interface.url = app.interface.path + '?' + e.menuItemId;
      chrome.storage.local.set({"context": e.menuItemId}, function () {
        var popup = e.menuItemId === "popup" ? app.interface.url : '';
        chrome.browserAction.setPopup({"popup": popup}, function () {});
      });
    });
  },
  "create": {
    "button": function () {
      chrome.storage.local.get({"context": "popup"}, function (storage) {
        var popup = storage.context === "popup", win = storage.context === "win", tab = storage.context === "tab";
        /*  */
        chrome.contextMenus.create({"id": "tab", "type": "radio", "title": "Open in tab",  "contexts": ["browser_action"], "checked": tab, "onclick": app.contextmenu.click});
        chrome.contextMenus.create({"id": "win", "type": "radio", "title": "Open in window",  "contexts": ["browser_action"], "checked": win, "onclick": app.contextmenu.click});
        chrome.contextMenus.create({"id": "popup", "type": "radio", "title": "Open in popup",  "contexts": ["browser_action"], "checked": popup, "onclick": app.contextmenu.click});
      });
    },
    "page": function (callback) {
      chrome.contextMenus.create({
        "contexts": ["link"],
        "title": "Download with accelerator :: " + "file",
        "onclick": function (e) {callback(e.linkUrl || '')}
      });
      /*  */
      chrome.contextMenus.create({
        "contexts": ["image"],
        "title": "Download with accelerator :: " + "image",
        "onclick": function (e) {callback(e.srcUrl || '')}
      });
      /*  */
      chrome.contextMenus.create({
        "contexts": ["video", "audio"],
        "title": "Download with accelerator :: " + "media",
        "onclick": function (e) {callback(e.srcUrl || '')}
      });
    }
  }
};
