app.download = {
  "showDefaultFolder": function () {
    if (chrome.downloads.showDefaultFolder) {
      chrome.downloads.showDefaultFolder();
    }
  },
  "pause": function (e) {
    try {
      manager.pause(e.id, function () {
        config.listener(true);
      });
    } catch (e) {config.log(e)}
  },
  "resume": function (e) {
    try {
      manager.resume(e.id, function () {
        config.listener(true);
      });
    } catch (e) {config.log(e)}
  },
  "cancel": function (e) {
    try {
      manager.cancel(e.id, function () {
        config.listener(true);
      });
    } catch (e) {config.log(e)}
  },
  "onchanged": function (callback) {
    manager.onChanged.addListener(function (e) {
      e["changed"] = true;
      callback(e);
    });
  },
  "search": function (query, callback) {
    try {
      manager.search(query, function (e) {
        callback(e);
      });
    } catch (e) {config.log(e)}
  },
  "open": function (e) {
    app.download.search(e, function (arr) {
      if (arr && arr.length === 1) {
        if (arr[0].state === "complete") {
          chrome.downloads.open(arr[0].id);
        }
      }
    });
  },
  "getFileIcon": function (e, callback) {
    try {
      manager.getFileIcon(e.id,	{"size": 32},	function (src) {
        var lastError = chrome.runtime.lastError;
        callback({
          "id": e.id,
          "src": src || "unknown.png",
          "fileextension": e.fileextension
        });
      });
    } catch (e) {config.log(e)}
  },
  "removeFile": function (e, callback) {
    app.download.search(e, function (arr) {
      if (arr && arr.length === 1) {
        if (arr[0].exists === true) {
          if (arr[0].state === "complete") {
            chrome.downloads.removeFile(arr[0].id, function () {
              try {
                manager.erase(e, callback);
              } catch (e) {config.log(e)}
            });
          }
        }
      }
    });
  },
  "erase": function (e, callback) {
    if (e) {
      try {
        manager.erase(e, callback);
      } catch (e) {config.log(e)}
    } else {
      app.download.search({}, function (arr) {
        for (var i = 0; i < arr.length; i++) {
          if (arr[i].state !== "in_progress") {
            try {
              manager.erase({"id": arr[i].id}, callback);
            } catch (e) {config.log(e)}
          }
        }
      });
    }
  },
  "download": function (url) {
    if (url) {
      try {
        manager.download({"url": url}, () => {}, {
          "max-retires": 5,
          "speed-over-seconds": 10,
          "max-simultaneous-writes": 3,
          "overwrite-segment-size": true,
          "use-native-when-possible": true,
          "min-segment-size": 1 * 1024 * 1024,
          "max-segment-size": 10 * 1024 * 1024,
          "absolute-max-segment-size": 100 * 1024 * 1024,
          "max-number-of-threads": config.download.threads
        });
      } catch (e) {config.log(e)}
      /*  */
      config.listener(true);
    } else {
      app.notifications.create("Empty URL!\nPlease add a correct URL and try again.");
    }
  }
};
